Subject: Re: [PATCH REPOST 1/2] NET: Accurate packet scheduling for ATM/ADSL (kernel)

From: Patrick McHardy <[email-masked]>
Date: Thu, 25 Jan 2007 01:06:26 +0100

Russell Stuart wrote:
> Yuk!  Now the user has to say whether he wants to use
> STAB's or not?  Currently, apart from some debugging
> params to tc, the user isn't even aware that the 
> traffic control is implemented in terms of RTAB's.  
> That is how it should be - it is an implementation 
> detail.

Of course he has to, just like your "atm" parameter. In case
of stabs it would be something like "stab atm".

>>I think this is a different problem. If you replace RTABs
>>by STABs you again can't use it for anything that is only
>>interested in the size, not the transmission time (HFSC,
>>SFQ, ...).
> 
> 
> I was a little too brief.
> 
> The comment stems from the observation that in all
> current implementations:
> 
>    const A_CONSTANT;
>    for (i = 0; i < 256; i += 1)
>      assert(RTAB[i] == STAB[i] * A_CONSTANT);
> 
> Ergo, if in addition to implementing STAB as you
> plan to, A_CONSTANT was shipped to the kernel then
> RTAB could be replaced.

At least look at the patch I sent. STAB mapping is _not_ a
multiplication by a constant (which wouldn't be able to
express minimum packet size or padding to multiples of cell
sizes).